from miru.test import unittest
from miru import imiru

from zope.interface import implements

class WorldObject:
    implements(imiru.IWorldObject)

class Draggable:
    implements(imiru.IDraggable)

class Kamera:
    implements(imiru.ICamera)
    wireframe = False
    def render(self, **kw):
        pass

class TestHandlers(unittest.TestCase):

    def testTranslationHandlerAdaption(self):
        s = set()
        o = WorldObject()
        handler = imiru.ITranslationHandler(o)
        s.add(handler)
        o = Draggable()
        handler = imiru.ITranslationHandler(o)
        s.add(handler)
        o = Kamera()
        handler = imiru.ITranslationHandler(o)
        s.add(handler)
        self.assertEquals(3, len(s))

    def testRotationHandlerAdaption(self):
        s = set()
        o = WorldObject()
        handler = imiru.IRotationHandler(o)
        s.add(handler)
        o = Draggable()
        handler = imiru.IRotationHandler(o)
        s.add(handler)
        o = Kamera()
        handler = imiru.IRotationHandler(o)
        s.add(handler)
        # Camera and WorldObjects use the same provider
        self.assertEquals(2, len(s))

