# mluffel's actions

from miru.environment import env
from miru import common

from roboto import actor
from roboto import scene

clock = scene.scheduler

import random
import euclid

class MultipleStepMotion(actor.BaseAction):
    
    def __init__(self, actor, steps):
        self.actor = actor
        self.currentStep = 0
        self.stepTime = 0
        self.steps = steps
        #self.steps = [euclid.Vector2(*p) for p in self.steps]
        # between steps
        r,c = self.actor.row,self.actor.col
        rcs = [(r,c)]
        for step in self.steps:
            r,c = r+step[0],c+step[1]
            rcs.append((r,c))
        
        self.futurePos = [euclid.Vector3(*scene.getPos(r,c)) for r,c in rcs]
        self.computeStepLocations()
    
    def computeStepLocations(self):
        self.prevLoc = self.futurePos[self.currentStep]
        self.nextLoc = self.futurePos[self.currentStep+1]
        self.stepSpeed = 1/(self.prevLoc-self.nextLoc).magnitude()
    
    def update(self, dt):   
        self.stepTime += dt#*self.stepSpeed
        if self.stepTime > 1:
            self.stepTime = 0
            
            self.currentStep += 1
            if self.currentStep >= len(self.steps):
                self.fuckingStop()
            else:
                self.computeStepLocations()
        else:
            
            self.actor.actor_obj.pos = lerp(self.prevLoc, self.nextLoc, self.stepTime)

from math import pi,cos
unpi = 1/pi
def lerp(a,b,i):
    i = cos(i*pi)*0.5+0.5
    return a*i + b*(1-i)


def Curl(actor, up, right):
    if up:
        if right:
            return UpwardRightCurl(actor)
        else:
            return UpwardLeftCurl(actor)
    else:
        if right:
            return DownwardRightCurl(actor)
        else:
            return DownwardLeftCurl(actor)

def DownwardRightCurl(actor):
    return MultipleStepMotion(actor, [(0,1), (2,0), (0,-1)])

def DownwardLeftCurl(actor):
    return MultipleStepMotion(actor, [(0,1), (-2,0), (0,-1)])

def UpwardRightCurl(actor):
    return MultipleStepMotion(actor, [(0,-1), (2,0), (0,1)])

def UpwardLeftCurl(actor):
    return MultipleStepMotion(actor, [(0,-1), (-2,0), (0,1)])


