from twisted.internet import task
from pyglet import clock

class Clock(clock.Clock):

    period_limit = False
    _looping_calls = {}
    _delayed_calls = {}

    #def schedule(self, f, *a, **kw):
    #    self._scheduled[id(f)] = (f, a, kw)

    def schedule_interval(self, f, interval, *a, **kw):
        sched_call = task.LoopingCall(f, *a, **kw)
        sched_call.start(interval, False)
        self._looping_calls[id(f)] = sched_call

    def schedule_interval_soft(self, f, interval, *a, **kw):
        pass

    def schedule_once(self, f, delay, *a, **kw):
        from twisted.internet import reactor
        def _wrapcall():
            f(*a, **kw)
            if self._delayed_calls.has_key(id(f)):
                del self._delayed_calls[id(f)]
        delayed = reactor.callLater(delay, _wrapcall)
        self._delayed_calls[id(f)] = delayed

    def unschedule(self, f):
        clock.Clock.unschedule(self, f)
        if self._looping_calls.has_key(id(f)):
            sched = self._looping_calls[id(f)]
            sched.stop()
            del self._looping_calls[id(f)]
        if self._delayed_calls.has_key(id(f)):
            d = self._delayed_calls[id(f)]
            d.cancel()
            del self._delayed_calls[id(f)]
        

_clock = Clock()
clock.set_default(_clock)

