from miru import camera

from roboto import scene
from roboto import constants

def loadDirectionalWhite(mod, env):
    dl = camera.DirectionalLight(diffuse=(0.9,0.7,0.7,1))
    dl.lpos[:] = (1,5,2,3)
    env.camera.lights.append(dl)

scene.registerLightLoader('directional-white', loadDirectionalWhite)

def loadDirectionalMagenta(mod, env):
    dl = camera.DirectionalLight(diffuse=(0.9,0.6,0.9,1))
    dl.lpos[:] = (1,5,2,3)
    env.camera.lights.append(dl)

scene.registerLightLoader('directional-magenta', loadDirectionalMagenta)


def loadDirectionalRed(mod, env):
    dl = camera.DirectionalLight(ambient=(0.9,0.2,0.1,1),diffuse=(0.9,0.2,0.1,1))
    env.camera.lights.append(dl)

scene.registerLightLoader('directional-red', loadDirectionalRed)

def loadPositionalWhiteLeft(mod, env):
    rows, cols = scene.getFloorDimensions()
    print 'floor dims', rows, cols
    z = -(scene.TILE_WIDTH * cols) / 2.0
    pl = camera.PositionalLight(pos=(-0.29, 1.76, z), debug=constants.DEBUG)
    env.camera.lights.append(pl)

scene.registerLightLoader('positional-white-left', loadPositionalWhiteLeft)

def loadPositionalWhiteRight(mod, env):
    rows, cols = scene.getFloorDimensions()
    z = -(scene.TILE_WIDTH * cols) / 2.0
    x = (scene.TILE_LENGTH * rows) - 0.29
    pl = camera.PositionalLight(pos=(x, 0.76, z), debug=constants.DEBUG)
    env.camera.lights.append(pl)

scene.registerLightLoader('positional-white-right', loadPositionalWhiteRight)

def loadPositionalWhiteBack(mod, env):
    rows, cols = scene.getFloorDimensions()
    z = -(scene.TILE_WIDTH * cols) + 1.5
    x = ((scene.TILE_LENGTH * rows)) / 2.0
    pl = camera.PositionalLight(pos=(x, 1.76, z), debug=constants.DEBUG)
    env.camera.lights.append(pl)


scene.registerLightLoader('positional-white-back', loadPositionalWhiteBack)


