from pyglet.window import key
from pyglet import font
from miru.environment import env
from roboto import events

RED = (1, 0, 0, 1)
WHITE = (1, 1, 1, 1)
SELECTED = RED
FONTDEF = ('Arial', 36)


def Play():
  print "Time to play!" 
  events.levelTransitionEvent.transition()


def Help():
  print "Help a brutha!" 


def Quit():
  print "There is no try only do!" 


HANDLERS = (Play, Help, Quit)


class Menu(object):
    def __init__(self, loc, handlers=None, fontdef=None):
        self.loc = loc
        self.hidden = True
        handlers = handlers or HANDLERS
        fontdef = fontdef or FONTDEF
        ft = font.load(*fontdef)
        self.items = []
        self.current = 0
        x, y = loc
        for h in handlers: 
            t = font.Text(ft, h.__name__, x=x, y=y)
            t.handler = h
            self.items.append(t)
            y -= (fontdef[1] + 10)

        self.items[self.current].color = SELECTED

    def change_selection(self, direction):
        items = self.items
        end = len(items) - 1
        current = self.current
        items[current].color = WHITE 

        current += direction
        if current > end:
          current = 0
        elif current < 0:
          current = end

        self.current = current
        items[self.current].color = SELECTED

    def draw(self):
        for i in self.items:
            i.draw()

    def show(self):
        env.osd.addobj(self) 
        env.window.push_handlers(self.on_key_press, self.on_mouse_press)
        self.hidden = False

    def hide(self):
        env.osd.delobj(self) 
        self.hidden = True

    def on_key_press(self, symbol, modifiers):
        if self.hidden:
          return

        if symbol == key.UP:
            self.change_selection(-1)
        elif symbol == key.DOWN:
            self.change_selection(1)
        elif symbol == key.RETURN:
            # Selection made
            self.items[self.current].handler()

    def on_mouse_press(self, x, y, button, modifiers):
        print "got mouse press!", x, y, button, modifiers
